%global gem_name railties

%bcond_without bootstrap

Name: rubygem-%{gem_name}
Version: 7.0.8
Release:    1%{?dist}
Summary: Tools for creating, working with, and running Rails applications
License: MIT
URL: http://rubyonrails.org
Source0: https://rubygems.org/gems/%{gem_name}-%{version}%{?prerelease}.gem
Source1: %{gem_name}-%{version}%{?prerelease}-tests.txz
Source2: rails-%{version}%{?prerelease}-tools.txz
Patch1: rubygem-railties-7.0.2.3-Remove-the-multi-call-form-of-assert_called_with.patch
Patch2: rubygem-railties-7.1.0-Fix-tests-for-minitest-5.16.patch
Patch3: rubygem-railties-7.1.0-Fix-unmarshalable-test-for-minitest-5.16.3.patch

Recommends: rubygem(irb)
Suggests: %{_bindir}/sqlite3
Recommends: %{_bindir}/git
BuildRequires: ruby(release)
BuildRequires: rubygems-devel
BuildRequires: ruby >= 2.2.2
%if %{without bootstrap}
BuildRequires: rubygem(actioncable) = %{version}
BuildRequires: rubygem(actionmailer) = %{version}
BuildRequires: rubygem(actionpack) = %{version}
BuildRequires: rubygem(activerecord) = %{version}
BuildRequires: rubygem(activestorage) = %{version}
BuildRequires: rubygem(activesupport) = %{version}
BuildRequires: rubygem(bootsnap)
BuildRequires: rubygem(bundler)
BuildRequires: rubygem(capybara)
BuildRequires: rubygem(dalli)
BuildRequires: rubygem(importmap-rails)
BuildRequires: rubygem(irb)
BuildRequires: rubygem(listen)
BuildRequires: rubygem(method_source)
BuildRequires: rubygem(mysql2)
BuildRequires: rubygem(pg)
BuildRequires: rubygem(puma)
BuildRequires: rubygem(rack-cache)
BuildRequires: rubygem(rails)
BuildRequires: rubygem(rake) >= 0.8.7
BuildRequires: rubygem(selenium-webdriver)
BuildRequires: rubygem(sprockets-rails)
BuildRequires: rubygem(sqlite3)
BuildRequires: rubygem(thor) >= 0.18.1
BuildRequires: rubygem(zeitwerk)
BuildRequires: rubygem(webrick)
BuildRequires: %{_bindir}/git
BuildRequires: %{_bindir}/memcached
BuildRequires: %{_bindir}/postgres
BuildRequires: %{_bindir}/sqlite3
BuildRequires: tzdata
%endif
BuildArch: noarch

%description
Rails internals: application bootup, plugins, generators, and rake tasks.
Railties is responsible to glue all frameworks together. Overall, it:
* handles all the bootstrapping process for a Rails application;
* manages rails command line interface;
* provides Rails generators core;

%package doc
Summary: Documentation for %{name}
Requires: %{name} = %{version}-%{release}
BuildArch: noarch

%description doc
Documentation for %{name}.

%prep
%setup -q -n %{gem_name}-%{version}%{?prerelease} -b1 -b2

pushd %{_builddir}
%patch 1 -p2
%patch 2 -p2
%patch 3 -p2
popd

%build
gem build ../%{gem_name}-%{version}%{?prerelease}.gemspec
%gem_install

%install
mkdir -p %{buildroot}%{gem_dir}
cp -a .%{gem_dir}/* \
        %{buildroot}%{gem_dir}/


mkdir -p %{buildroot}%{_bindir}
cp -p .%{_bindir}/* \
        %{buildroot}%{_bindir}/

find %{buildroot}%{gem_instdir}/exe -type f | xargs chmod a+x

%if %{without bootstrap}
%check
ln -s %{gem_dir}/specifications/rails-%{version}%{?prerelease}.gemspec .%{gem_dir}/gems/rails.gemspec
ln -s %{gem_dir}/gems/actionview-%{version}%{?prerelease}/ .%{gem_dir}/gems/actionview
ln -s ${PWD}%{gem_instdir} .%{gem_dir}/gems/railties

pushd .%{gem_dir}/gems/railties

ln -s %{_builddir}/tools ..
mv %{_builddir}/test .

echo '%{version}%{?prerelease}' > ../RAILS_VERSION

touch ../Gemfile
echo 'gem "actioncable"' >> ../Gemfile
echo 'gem "actionmailer"' >> ../Gemfile
echo 'gem "actionpack"' >> ../Gemfile
echo 'gem "activerecord"' >> ../Gemfile
echo 'gem "activestorage"' >> ../Gemfile
echo 'gem "activesupport"' >> ../Gemfile
echo 'gem "bootsnap"' >> ../Gemfile
echo 'gem "capybara"' >> ../Gemfile
echo 'gem "dalli"' >> ../Gemfile
echo 'gem "importmap-rails"' >> ../Gemfile
echo 'gem "irb"' >> ../Gemfile
echo 'gem "listen"' >> ../Gemfile
echo 'gem "method_source"' >> ../Gemfile
echo 'gem "mysql2"' >> ../Gemfile
echo 'gem "pg"' >> ../Gemfile
echo 'gem "puma"' >> ../Gemfile
echo 'gem "rack-cache"' >> ../Gemfile
echo 'gem "rails"' >> ../Gemfile
echo 'gem "rake"' >> ../Gemfile
echo 'gem "rdoc"' >> ../Gemfile
echo 'gem "selenium-webdriver"' >> ../Gemfile
echo 'gem "sprockets-rails"' >> ../Gemfile
echo 'gem "sqlite3"' >> ../Gemfile
echo 'gem "thor"' >> ../Gemfile
echo 'gem "webrick"' >> ../Gemfile

export RUBYOPT="-I${PWD}/../railties/lib"
export PATH="${PWD}/../railties/exe:$PATH"
export BUNDLE_GEMFILE=${PWD}/../Gemfile

PG_DIR=$(mktemp -d)
PG_DATA_DIR=${PG_DIR}/data
export PGHOST=localhost
initdb -E UTF8 --no-locale -D ${PG_DATA_DIR}
pg_ctl -o "-p 5432 -k ${PG_DIR}" -D ${PG_DATA_DIR} -l ${PG_DIR}/logfile start

MC_PID=%(mktemp)
memcached -d -P "${MC_PID}"

sed -i -e '/require..minitest.retry./ s/^/#/' \
  test/isolation/abstract_unit.rb

mkdir test/isolation/assets/node_modules

sed -i '/test "i18n files have lower priority than application ones" do$/,/^    end$/ s/^/#/' \
  test/railties/engine_test.rb

sed -i '/test "displays statement invalid template correctly" do/a\
    skip' test/application/middleware/exceptions_test.rb

sed -i '/test_template_from_url/a\
    skip' test/generators/app_generator_test.rb

sed -r -i '/test_(hotwire|css_option_with_(asset_pipeline_tailwind|cssbundling_gem))/a\
    skip' test/generators/app_generator_test.rb

sed -i '/^\s*def test_create_migrations/ a \  skip' \
  test/generators/action_mailbox_install_generator_test.rb
mv test/commands/routes_test.rb{,.disable}

git config --global init.defaultBranch master

find test -type f -name '*_test.rb' -print0 | \
  sort -z | \
  xargs -0 -n1 -i sh -c "echo '* Test file: {}'; bundle exec ruby -Itest -- '{}' || exit 255"

kill -TERM $(< "${MC_PID}")

pg_ctl -D ${PG_DATA_DIR} stop
rm -rf ${PG_DIR}
popd
%endif

%files
%dir %{gem_instdir}
%{_bindir}/rails
%license %{gem_instdir}/MIT-LICENSE
%{gem_instdir}/exe
%{gem_libdir}
%exclude %{gem_cache}
%{gem_spec}

%files doc
%doc %{gem_docdir}
%doc %{gem_instdir}/CHANGELOG.md
%doc %{gem_instdir}/RDOC_MAIN.rdoc
%doc %{gem_instdir}/README.rdoc

%changelog
* Wed Jul 17 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 7.0.8-1
- initial build
